
open Markup_document
open Markup_yacc
open Markup_dtd

val write_document : out_channel -> 'ext document -> unit
    (* Writes O'Caml code to the out_channel that is a top-level function
     * creating a fresh document which is equal to the passed document:
     *
     * "let create_document warner map = ...;;"
     *
     * If you compile the code and call "create_document warner map"  the 
     * function creates a document tree which is equal to the passed document.
     * 
     * 'warner': a collect_warnings object
     * 'map': a domspec
     *)

  
val write_dtd : out_channel -> dtd -> unit
    (* Writes O'Caml code to the out_channel that is a top-level function
     * creating a fresh DTD which is equal to the passed DTD:
     *
     * "let create_dtd warner = ...;;"
     *
     * If you compile the code and call "create_dtd warner"  the 
     * function creates a DTD object which is equal to the passed object.
     * 
     * 'warner': a collect_warnings object
     *)

val write_subtree : out_channel -> 'ext node -> unit
    (* Writes O'Caml code to the out_channel that is a top-level function
     * creating a fresh node tree which is equal to the passed tree:
     *
     * "let create_subtree dtd map = ...;;"
     *
     * If you compile the code and call "create_subtree dtd map"  the 
     * function creates a DTD object which is equal to the passed object.
     * 
     * 'dtd': a DTD object
     * 'map': a domspec
     *)


  

