(* Sorry, this is currently undocumented *)
type state =
    At_beginning
  | First_token of Markup_lexer_types.token
  | In_stream
  | At_end
class virtual entity :
  (< gen_entity : string ->
                  (< close_entity : Markup_lexer_types.lexers;
                     cur_entline : int; cur_entname : string;
                     next_token : Markup_lexer_types.token;
                     open_entity : bool -> Markup_lexer_types.lexers -> 'c;
                     position_string : string;
                     set_debugging_mode : bool -> 'd; .. >
                   as 'b);
     par_entity : string -> 'b; .. >
   as 'a) ->
  string ->
  'e ->
  bool ->
  object
    val mutable accept_prolog : bool
    val mutable allow_conditionals : bool
    val mutable check_text_declaration : bool
    val mutable column : int
    val mutable cond_level : int
    val mutable debug : bool
    val mutable delegated_entity : 'b option
    val mutable dtd : 'a
    val errors_with_line_numbers : bool
    val mutable filename : string
    val mutable force_parameter_entity_parsing : bool
    val mutable last_token : Markup_lexer_types.token
    val mutable lex_id : Markup_lexer_types.lexers
    val mutable lexbuf : Lexing.lexbuf
    val mutable line : int
    val mutable name : string
    val mutable normalize_newline : bool
    val mutable pos : int
    val mutable poscomm_file : string
    val mutable prolog : Markup_lexer_types.prolog_token list option
    val mutable prolog_pairs : (string * string) list
    val mutable space_seen : bool
    val mutable warner : 'e
    method virtual close_entity : Markup_lexer_types.lexers
    method cur_entline : int
    method cur_entname : string
    method cur_pos : string
    method private err_name : string
    method private full_name : string
    method get_filename : string
    method is_ndata : bool
    method lexbuf : Lexing.lexbuf
    method name : string
    method private next_ignored_token : unit -> Markup_lexer_types.token
    method next_token : Markup_lexer_types.token
    method private next_token_from_entity : unit -> Markup_lexer_types.token
    method private next_token_from_this_entity :
      unit -> Markup_lexer_types.token
    method virtual open_entity : bool -> Markup_lexer_types.lexers -> unit
    method position_string : string
    method virtual replacement_text : string * bool
    method set_debugging_mode : bool -> unit
    method private virtual set_encoding : string -> unit
    method set_poscomm_file : string -> unit
    method xml_declaration : (string * string) list option
  end
class ndata_entity :
  string ->
  Markup_types.ext_id ->
  string ->
  object
    val mutable ext_id : Markup_types.ext_id
    val mutable name : string
    val mutable notation : string
    method close_entity : Markup_lexer_types.lexers
    method cur_entline : int
    method cur_entname : string
    method cur_pos : string
    method ext_id : Markup_types.ext_id
    method get_filename : string
    method is_ndata : bool
    method lexbuf : Lexing.lexbuf
    method name : string
    method next_token : Markup_lexer_types.token
    method notation : string
    method open_entity : bool -> Markup_lexer_types.lexers -> unit
    method position_string : string
    method replacement_text : string * bool
    method set_debugging_mode : bool -> unit
    method private set_encoding : string -> 'a
    method set_poscomm_file : string -> unit
    method xml_declaration : (string * string) list option
  end
class external_entity :
  Markup_reader.resolver ->
  (< gen_entity : string ->
                  (< close_entity : Markup_lexer_types.lexers;
                     cur_entline : int; cur_entname : string;
                     next_token : Markup_lexer_types.token;
                     open_entity : bool -> Markup_lexer_types.lexers -> 'c;
                     position_string : string;
                     replacement_text : string * 'd;
                     set_debugging_mode : bool -> 'e; .. >
                   as 'b);
     par_entity : string -> 'b; .. >
   as 'a) ->
  string ->
  (< warn : string -> 'g; .. > as 'f) ->
  Markup_types.ext_id ->
  bool ->
  bool ->
  object
    val mutable accept_prolog : bool
    val mutable allow_conditionals : bool
    val mutable check_text_declaration : bool
    val mutable column : int
    val mutable cond_level : int
    val mutable debug : bool
    val mutable delegated_entity : 'b option
    val mutable dtd : 'a
    val errors_with_line_numbers : bool
    val ext_id : Markup_types.ext_id
    val mutable filename : string
    val mutable force_parameter_entity_parsing : bool
    val mutable last_token : Markup_lexer_types.token
    val mutable lex_id : Markup_lexer_types.lexers
    val mutable lexbuf : Lexing.lexbuf
    val mutable line : int
    val mutable name : string
    val mutable normalize_newline : bool
    val p_special_empty_entities : bool
    val mutable pos : int
    val mutable poscomm_file : string
    val mutable prolog : Markup_lexer_types.prolog_token list option
    val mutable prolog_pairs : (string * string) list
    val resolver : Markup_reader.resolver
    val mutable resolver_is_open : bool
    val mutable space_seen : bool
    val mutable state : state
    val mutable warner : 'f
    method close_entity : Markup_lexer_types.lexers
    method cur_entline : int
    method cur_entname : string
    method cur_pos : string
    method private err_name : string
    method private full_name : string
    method get_filename : string
    method is_ndata : bool
    method lexbuf : Lexing.lexbuf
    method name : string
    method private next_ignored_token : unit -> Markup_lexer_types.token
    method next_token : Markup_lexer_types.token
    method private next_token_from_entity : unit -> Markup_lexer_types.token
    method private next_token_from_this_entity :
      unit -> Markup_lexer_types.token
    method open_entity : bool -> Markup_lexer_types.lexers -> unit
    method position_string : string
    method replacement_text : string * bool
    method set_debugging_mode : bool -> unit
    method private set_encoding : string -> unit
    method set_poscomm_file : string -> unit
    method xml_declaration : (string * string) list option
  end
class document_entity :
  Markup_reader.resolver ->
  (< gen_entity : string ->
                  (< close_entity : Markup_lexer_types.lexers;
                     cur_entline : int; cur_entname : string;
                     next_token : Markup_lexer_types.token;
                     open_entity : bool -> Markup_lexer_types.lexers -> 'c;
                     position_string : string;
                     replacement_text : string * 'd;
                     set_debugging_mode : bool -> 'e; .. >
                   as 'b);
     par_entity : string -> 'b; .. >
   as 'a) ->
  string ->
  (< warn : string -> 'g; .. > as 'f) ->
  Markup_types.ext_id ->
  bool ->
  object
    val mutable accept_prolog : bool
    val mutable allow_conditionals : bool
    val mutable check_text_declaration : bool
    val mutable column : int
    val mutable cond_level : int
    val mutable debug : bool
    val mutable delegated_entity : 'b option
    val mutable dtd : 'a
    val errors_with_line_numbers : bool
    val ext_id : Markup_types.ext_id
    val mutable filename : string
    val mutable force_parameter_entity_parsing : bool
    val mutable last_token : Markup_lexer_types.token
    val mutable lex_id : Markup_lexer_types.lexers
    val mutable lexbuf : Lexing.lexbuf
    val mutable line : int
    val mutable name : string
    val mutable normalize_newline : bool
    val p_special_empty_entities : bool
    val mutable pos : int
    val mutable poscomm_file : string
    val mutable prolog : Markup_lexer_types.prolog_token list option
    val mutable prolog_pairs : (string * string) list
    val resolver : Markup_reader.resolver
    val mutable resolver_is_open : bool
    val mutable space_seen : bool
    val mutable state : state
    val mutable warner : 'f
    method close_entity : Markup_lexer_types.lexers
    method cur_entline : int
    method cur_entname : string
    method cur_pos : string
    method private err_name : string
    method private full_name : string
    method get_filename : string
    method is_ndata : bool
    method lexbuf : Lexing.lexbuf
    method name : string
    method private next_ignored_token : unit -> Markup_lexer_types.token
    method next_token : Markup_lexer_types.token
    method private next_token_from_entity : unit -> Markup_lexer_types.token
    method private next_token_from_this_entity :
      unit -> Markup_lexer_types.token
    method open_entity : bool -> Markup_lexer_types.lexers -> unit
    method position_string : string
    method replacement_text : string * bool
    method set_debugging_mode : bool -> unit
    method private set_encoding : string -> unit
    method set_poscomm_file : string -> unit
    method xml_declaration : (string * string) list option
  end
class internal_entity :
  (< gen_entity : string ->
                  (< close_entity : Markup_lexer_types.lexers;
                     cur_entline : int; cur_entname : string;
                     next_token : Markup_lexer_types.token;
                     open_entity : bool -> Markup_lexer_types.lexers -> 'c;
                     position_string : string;
                     replacement_text : string * bool;
                     set_debugging_mode : bool -> 'd; .. >
                   as 'b);
     par_entity : string -> 'b; .. >
   as 'a) ->
  string ->
  (< warn : string -> 'f; .. > as 'e) ->
  string ->
  bool ->
  bool ->
  object
    val mutable accept_prolog : bool
    val mutable allow_conditionals : bool
    val mutable check_text_declaration : bool
    val mutable column : int
    val mutable cond_level : int
    val mutable contains_external_references : bool
    val mutable debug : bool
    val mutable delegated_entity : 'b option
    val mutable dtd : 'a
    val errors_with_line_numbers : bool
    val mutable filename : string
    val mutable force_parameter_entity_parsing : bool
    val mutable is_open : bool
    val mutable last_token : Markup_lexer_types.token
    val mutable lex_id : Markup_lexer_types.lexers
    val mutable lexbuf : Lexing.lexbuf
    val mutable line : int
    val mutable name : string
    val mutable normalize_newline : bool
    val p_internal_subset : bool
    val mutable p_parsed_actually : bool
    val mutable pos : int
    val mutable poscomm_file : string
    val mutable prolog : Markup_lexer_types.prolog_token list option
    val mutable prolog_pairs : (string * string) list
    val mutable replacement_text : string
    val mutable space_seen : bool
    val mutable state : state
    val mutable warner : 'e
    method close_entity : Markup_lexer_types.lexers
    method cur_entline : int
    method cur_entname : string
    method cur_pos : string
    method private err_name : string
    method private full_name : string
    method get_filename : string
    method is_ndata : bool
    method lexbuf : Lexing.lexbuf
    method name : string
    method private next_ignored_token : unit -> Markup_lexer_types.token
    method next_token : Markup_lexer_types.token
    method private next_token_from_entity : unit -> Markup_lexer_types.token
    method private next_token_from_this_entity :
      unit -> Markup_lexer_types.token
    method open_entity : bool -> Markup_lexer_types.lexers -> unit
    method position_string : string
    method replacement_text : string * bool
    method set_debugging_mode : bool -> unit
    method private set_encoding : string -> unit
    method set_poscomm_file : string -> unit
    method xml_declaration : (string * string) list option
  end
